( $Id: colordump.frt,v 1.1 2010/12/17 12:11:20 leon Exp albert $ )
( Copyright{2005}: Albert van der Horst, HCC FIG Holland by GNU Public License)

\ Dump storage with unspecified content to ADDRESS2 from ADDRESS1.
\ Modified to not even print "resb".
: (DUMP-N)'  DUP CR+dn - DROP CR   ;
'(DUMP-N)' '(DUMP-N) 3 CELLS MOVE

 '-dn- DEFAULT-DISASSEMBLY !

\ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
\ General note: this is just a copy of the ``-dl:'' stuff for dumping
\ words, with an adaptation at the lowest level.

\ Dump COLORNAME in a reassemblable fashion.
\ ."$" is used instead of ``TYPE'' such that a colorname may contain embedded
\ quotes.
: .DUMP-CN      0 PAD ! (CN>ASC) ."$" " >CN " TYPE ;

\ Dump colornames from host ADDRESS1 to ADDRESS2.
: (DUMP-LCN)   DO I DUP CR+dl @ .DUMP-CN 4 +LOOP PRINT-OLD-COMMENT: CR   ;

\ Dump words from target ADDRESS1 to ADDRESS2 adorned with labels.
: DUMP-LCN   TARGET>HOST SWAP TARGET>HOST  DUP NEXT-CUT ! (DUMP-LCN) ;
\ Define colornames section from target ADDRESS1 to ADDRESS2 with NAME.
: -dlcn    2>R 'DUMP-LCN 2R> SECTION ;
\ Define such section from target ADDRESS1 to ADDRESS2 with "name".
: -dlcn:    (WORD) -dlcn ;
\ Define such section from target ADDRESS1 to ADDRESS2 anonymous.
: -dlcn-    NONAME$ -dlcn ;
'DUMP-LCN    '-dlcn:   ARE-COUPLED

\ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
\ Dump an (ascii) CHAR
: .ASC    DUP BL = IF DROP "BL" TYPE ELSE && EMIT EMIT THEN ;

\ Dump COLORCHAR in a reassemblable fashion.
: .DUMP-CC   C> .ASC " >C " TYPE ;

\ Dump colorchars host to ADDRESS1 from ADDRESS2.
: (DUMP-BCC)   CUT-SIZE @ >R   4 CUT-SIZE !
    DO I DUP CR+db C@ .DUMP-CC LOOP PRINT-OLD-COMMENT: CR
R> CUT-SIZE ! ;

\ Dump from target ADDRESS1 to ADDRESS2 adorned with labels.
: DUMP-BCC   TARGET>HOST SWAP TARGET>HOST  DUP NEXT-CUT ! (DUMP-BCC) ;
\ Define colorchars section from target ADDRESS1 to ADDRESS2 with NAME.
: -dbcc    2>R 'DUMP-BCC 2R> SECTION ;
\ Define such section from target ADDRESS1 to ADDRESS2 with "name".
: -dbcc:    (WORD) -dbcc ;
\ Define such section from target ADDRESS1 to ADDRESS2 anonymous.
: -dbcc-    NONAME$ -dbcc ;
'DUMP-BCC    '-dbcc:   ARE-COUPLED
\ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

\ Dump COLORCHAR in a reassemblable fashion.
: .DUMP-BIT   BASE @ >R   2 BASE !   0 <# 8 0 DO # LOOP BL HOLD #> TYPE
R> BASE ! ;

\ Dump words in binary to ADDRESS2 from ADDRESS1.
: (DUMP-BIT)   CUT-SIZE @ >R   2 CUT-SIZE !
    DO I DUP CR+db C@ .DUMP-BIT LOOP PRINT-OLD-COMMENT: CR
R> CUT-SIZE ! ;

\ Dump from target ADDRESS1 to ADDRESS2 adorned with labels.
: DUMP-BIT   TARGET>HOST SWAP TARGET>HOST  DUP NEXT-CUT ! (DUMP-BIT) ;
\ Define colorchars section from target ADDRESS1 to ADDRESS2 with NAME.
: -dbit    2>R 'DUMP-BIT 2R> SECTION ;
\ Define such section from target ADDRESS1 to ADDRESS2 with "name".
: -dbit:    (WORD) -dbit ;
\ Define such section from target ADDRESS1 to ADDRESS2 anonymous.
: -dbit-    NONAME$ -dbit ;
'DUMP-BIT    '-dbit:   ARE-COUPLED
\ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
\ General note: this is just a copy of the ``-dl:'' stuff for dumping
\ color screens, with an adaptation at the lowest level.

\ The following words are compiling things of the color indicated via
\ ``JUMP-TABLE''. All ``DUMP-'' accept a parse-pointer and a colortoken
\ print the colortoken approriately, then increment the parse-pointer.
\ Incidentally, an extra token is parsed.

: DUMP-COLOR:  CREATE $,
    DOES> $@ PAD $!  0F INVERT AND (CN>ASC) TYPE   BL EMIT 4 + ;

\ Copy COLORNAME to ``PAD'', return as a white (ascii) STRINGCONSTANT
: CN>WHITE  "(" PAD $!   (CN>ASC) ;

\ ADDR TOKEN : ADDR2
\ Dump token as a cop-out (comma).
\ There is just a comma-number, that reassembles itself when executed.
: .DUMP-COMMA   0 <# BL HOLD #S &, HOLD #> TYPE 4 + ;


\ ADDR TOKEN : ADDR2 . Handle words of that color.
":" DUMP-COLOR: .DUMP-RED
"^" DUMP-COLOR: .DUMP-CYAN
"]" DUMP-COLOR: .DUMP-GREEN
"[" DUMP-COLOR: .DUMP-YELLOW
"+" DUMP-COLOR: .DUMP-EXTEND
"." DUMP-COLOR: .DUMP-BLUE
"?" DUMP-COLOR: (.DUMP-VIOLET)          \ An extra word follows.

\ ADDR TOKEN : ADDR2 . Handle lower case words
: .DUMP-WHITE     0F INVERT AND CN>WHITE TYPE   BL EMIT 4 + ;

\ ADDR TOKEN : ADDR2 . Handle capitalized words
: .DUMP-WHITE-C   0F INVERT AND   CN>WHITE   OVER 1+ $20 TOGGLE   TYPE   BL EMIT 4 + ;

\ Convert ADDRESS LENGTH in place to upper case.
: $>UPPER BOUNDS DO I C@ &a &z 1+ WITHIN IF I C@ 20 XOR I C! THEN LOOP ;

\ ADDR TOKEN : ADDR2 . Handle upper case words
: .DUMP-WHITE-CC  0F INVERT AND   CN>WHITE   2DUP $>UPPER   TYPE   BL EMIT 4 + ;

\ Print N in decimal, i.e. preceeded by ``#''.
: .#   DECIMAL 0 <# BL HOLD #S &# HOLD #> HEX TYPE ;

\ Print N in hex, i.e. preceeded by ``$''.
: .$   0 <# BL HOLD #S &$ HOLD #> TYPE ;

\ For the green COMMA find the number of bytes it comprises.
: #BYTES   COMMA-BAG BAG-WHERE  COMMA-BAG - 4 / ;

\ Where we drop the color code for disassembly.
\ Although instruction can't run more that 4 bytes in colorforth,
\ they may be part of an incomplete instruction that runs larger
\ by an immediate word and an offset word.
CREATE CODEBUFFER 12 ALLOT

\ Do a disassembly return, dropping ADDRESS, that is always at ``CODEBUFFER''
\ anyway.
: CR+ DROP CR ;

\ If the NUMBER of bytes laid down doesn't agree where disassembly sits
\ correct before leaving the assembler.
ASSEMBLER
: CORRECT-END-POINT
    CODEBUFFER +   AS-POINTER @ - DUP IF . "AS-ALLOT" TYPE _ THEN DROP ;
PREVIOUS

\ ADDR TOKEN : ADDR2 . Handle disassembly of token, at most 4 bytes.
\ The length is got from the next token.
ASSEMBLER
: COLOR-DIS
    'CR+ >DFA @    'CR-ADORNED >DFA !
    "    {" TYPE   OVER 4 + @ #BYTES >R
    CODEBUFFER !    \ Drop code for disassembly. Should use AS-C, here.
    CODEBUFFER DUP R@ + DISASSEMBLE-RANGE
    R> CORRECT-END-POINT
    "    }" TYPE CR
    4 +
    'CR-ADORNED RESTORED ;
PREVIOUS

\ ADDR TOKEN : ADDR2 . Handle hex constants. Maybe disassemble.
: HEX-OR-DISAS    OVER CELL+ @ COMMA-BAG IN-BAG? IF COLOR-DIS ELSE
    &] EMIT   .$ THEN  ;


\ ADDR TOKEN : ADDR2 . Handle compiled hex/decimal constants.
: .DUMP-#GREEN   DUP 10 AND IF 5 RSHIFT HEX-OR-DISAS ELSE   &] EMIT   5 RSHIFT .# THEN
    4 + ;


\ ADDR TOKEN : ADDR2 . Handle hex long constants.
: .DUMP-#GREEN2  15 <> IF ." Can't deal behind that" THEN 4 +
     DUP @   HEX-OR-DISAS 4 + ;

\ ADDR TOKEN : ADDR2 . Handle hex long constants.
: .DUMP-#BROWN2  12 <> IF ." Can't deal behind that" THEN 4 +
     DUP @   &% EMIT   .$ 4 + ;

\ ADDR TOKEN : ADDR2 . Handle variables, parse an extra token, the content.
: .DUMP-VIOLET   (.DUMP-VIOLET) DUP @ .DUMP-COMMA ;

\ ADDR TOKEN : ADDR2 . Handle decimal/hex constants.
: .DUMP-#YELLOW   DUP 10 AND IF 5 RSHIFT .$ ELSE   5 RSHIFT .# THEN 4 + ;

CREATE JUMP-TABLE
'.DUMP-EXTEND   , '.DUMP-YELLOW    , '.DUMP-#BROWN2 , '.DUMP-RED   ,
'.DUMP-GREEN    , '.DUMP-#GREEN2   , '.DUMP-#GREEN  , '.DUMP-CYAN  ,
'.DUMP-#YELLOW  , '.DUMP-WHITE     , '.DUMP-WHITE-C , '.DUMP-WHITE-CC ,
'.DUMP-VIOLET  , '.DUMP-COMMA     , '.DUMP-BLUE   , '.DUMP-COMMA ,

\ For screen CELL execute action from jump-table.
: JUMP-THERE   DUP 0F AND CELLS JUMP-TABLE + @ EXECUTE ;

\ Handle cr at ADDRESS for colorcode.
: CR+cl DUP @ 1F AND 3 = IF DUP NEXT-CUT ! THEN CR+dn ;

\ Dump colorcode longs from host ADDRESS2 to ADDRESS1.
\ Supress printing of addresses.
: (DUMP-CL)
    BEGIN DUP CR+cl DUP @ JUMP-THERE 2DUP = UNTIL   2DROP
    PRINT-OLD-COMMENT: CR ;

\ Turn off disassembly of code by temporarily emptying the bag of commaers.
: NO-DIS    COMMA-BAG @ R> SWAP >R >R   COMMA-BAG !BAG   CO   R> COMMA-BAG ! ;

 \ Dump words from target ADDRESS1 to ADDRESS2 adorned with labels.
: DUMP-CL   TARGET>HOST SWAP TARGET>HOST  DUP NEXT-CUT ! (DUMP-CL) ;

 \ Dump words from target ADDRESS1 to ADDRESS2 adorned with labels.
: DUMP-CLNA   NO-DIS DUMP-CL ;

\ Define colornames section from target ADDRESS1 to ADDRESS2 with NAME.
: -dclna    2>R 'DUMP-CLNA 2R> SECTION ;

\ Define colornames section from target ADDRESS1 to ADDRESS2 with NAME.
: -dcl    2>R 'DUMP-CL 2R> SECTION ;
\ Define such section from target ADDRESS1 to ADDRESS2 with "name".
: -dcl:    (WORD) -dcl ;
\ Define such section from target ADDRESS1 to ADDRESS2 anonymous.
: -dcl-    NONAME$ -dcl ;
'DUMP-CL    '-dcl:   ARE-COUPLED

\ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
