( $Id: combine.frt,v 1.4 2010/12/17 17:11:41 leon Exp $ )
( Copyright{2000}: Albert van der Horst, HCC FIG Holland by GNU Public License)
( Uses Richard Stallmans convention. Uppercased word are parameters.    )

( Utility to use ASCII files as source for colorforth. )

: .usage
"Usage: combine <frame.cf> <screens.cf> <application.cf> 
Combines the screens from screens.cf into a colorforth frame work.
The result is placed in a separate file application.cf"
    TYPE CR ;

REQUIRE R/W
REQUIRE FALSE
REQUIRE NIP

1024 CONSTANT #screen   \ Screen length

\ For STRING: "It IS all zero"
: empty?   -TRAILING NIP 0= ;

\ To FILEHANDLE, write screen at BUFFER OFFSET.
: ONE-SCREEN 2DUP + #screen empty? IF DROP 2DROP EXIT THEN   ROT >R
   DUP 0 R@ REPOSITION-FILE THROW
   + #screen R> WRITE-FILE THROW ;

\ Add all the screens from the first argument to open FILE.
: add-screens   2 ARG[] GET-FILE
     0 DO !CSP 2DUP I ONE-SCREEN  ?CSP #screen +LOOP DROP CLOSE-FILE THROW ;

: MAIN   ARGC 4 <> IF .usage BYE THEN
   1 ARG[] GET-FILE 3 ARG[] PUT-FILE
   3 ARG[] R/W OPEN-FILE   THROW add-screens ;
