" Vim syntax file
" Language:    colorforth
" Maintainer:  Leon & SAlbert
" Last Change: 2010 nov 21
" Filenames:   *.cfs
" URL:         (original) http://www.cvjb.de/comp/vim/forth.vim

" $Id: $

" This is crudely adapted from forth.vim
" If you use this language, please improve it, and send me
" the patches.
" This is a defacto proposal for rendering colorforth in ascii files.
"

" ########################## PART COPIED FROM forth.vim  ################
" Some of this may not make sense for colorforth.

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
    syntax clear
elseif exists("b:current_syntax")
    finish
endif

" Synchronization method
syn sync ccomment
syn sync maxlines=200

" I use gforth, so I set this to case ignore
syn case ignore

" Some special, non-FORTH keywords
syn keyword forthTodo contained TODO FIXME XXX
syn match forthTodo contained 'Copyright\(\s([Cc])\)\=\(\s[0-9]\{2,4}\)\='

" Characters allowed in keywords
" I don't know if 128-255 are allowed in ANS-FORTH
if version >= 600
    setlocal iskeyword=!,@,33-35,%,$,38-64,A-Z,91-96,a-z,123-126,128-255
else
    set iskeyword=!,@,33-35,%,$,38-64,A-Z,91-96,a-z,123-126,128-255
endif

" when wanted, highlight trailing white space
if exists("forth_space_errors")
    if !exists("forth_no_trail_space_error")
        syn match forthSpaceError display excludenl "\s\+$"
    endif
    if !exists("forth_no_tab_space_error")
        syn match forthSpaceError display " \+\t"me=e-1
    endif
endif

" ########################## END OF PART COPIED FROM forth.vim ################

" Matching colorforth transcriptions.
" Here colors are syntax.
syn match forthGreen '\<\]\s*[^ \t]\+\>'
syn match forthGreenDecimal '\<\]\#\s*[^ \t]\+\>'
syn match forthGreenHex '\<\]\$\s*[^ \t]\+\>'
syn match forthYellow '\<\[\s*[^ \t]\+\>'
syn match forthYellowDecimal '\<\#\s*[^ \t]\+\>'
syn match forthMagenta '\<[?]\s*[^ \t]\+\>'
syn match forthYellowHex '\<\$m\?\s*[^ \t]\+\>'
syn match forthCyan '\<\^\s*[^ \t]\+\>'
syn match forthBlue '\<\.\s*[^ \t]\+\>'
syn match forthRed '\<:\s*[^ \t]\+\>'

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_forth_syn_inits")
    if version < 508
        let did_forth_syn_inits = 1
        command -nargs=+ HiLink hi link <args>
    else
        command -nargs=+ HiLink hi def link <args>
    endif

    " The default methods for highlighting. Can be overriden later.
    HiLink forthRed Define
    HiLink forthGreen Compiled
    HiLink forthGreenDecimal CompiledDec
    HiLink forthGreenHex     CompiledHex
    HiLink forthYellow Executed
    HiLink forthYellowDecimal ExecutedDec
    HiLink forthYellowHex ExecutedHex
    HiLink forthMagenta Variable
    HiLink forthCyan    Immediate
    " HiLink forthWhite Define
    HiLink forthBlue Layout
    "
    delcommand HiLink
endif

let b:current_syntax = "colorforth"

" vim:ts=8:sw=4:nocindent:smartindent:
